#pragma once

#include "TelescopeDll.h"

namespace Telescope
{
	class MemoryTag
	{
	public:
		static MemoryTag Create(const char* tag)
		{
			return MemoryTag(tag);
		}
		bool operator==(const MemoryTag& other)
		{
			return this == &other;
		}
		operator const char* () const
		{
			return m_tag;
		}
	private:
		MemoryTag(const char* tag)
			:m_tag(tag)
		{}
		const char* m_tag;
	};
}

#define TELESCOPE_DECLARE_MEMORY_TAG(v) \
extern "C" TELESCOPE_EXPORT Telescope::MemoryTag v;

#define TELESCOPE_DEFINE_MEMORY_TAG(v,t) \
extern "C" TELESCOPE_EXPORT Telescope::MemoryTag v = Telescope::MemoryTag::Create(t);
